Status: Closed Start date: 12 Feb 2017

Priority: Normal Due date:  

Assignee: John Abbott % Done: 100%

Category: New Function Estimated time: 1.01 hour

Target version: CoCoALib-0.99550 spring 2017 Spent time: 0.75 hour

Description

In utils.H there is a fn called square defined only for double.  It used only in ApproxPts.C.

I am sure that it is inappropriate to have that fn, so have moved it to ApproxPts.C.

Do we want to have a square function?

Related issues:

Related to CoCoALib - Design #1147: mySquare and myPowerSmallExp New 17 Jan 2018

History

#1 - 12 Feb 2017 16:19 - John Abbott

A search for square showed that there had been a square function for RingElem, but that it was removed (presumably with the idea that a user should

call power with second arg equal to 2).  I note that the fn square for RingElem called a special member fn mySquare (which may sometimes be faster

than myMul on two copies of the arg).

If we do put a general square fn somewhere, it should probably be a template fn:

template <typename T>

T square(const T& a)

{ return a*a; }

 

However, this defn would not use the mem fn RingBase::mySquare.

#2 - 12 Feb 2017 16:20 - John Abbott

- Status changed from New to In Progress

- % Done changed from 0 to 10

So far we have not really felt the need for a square function in CoCoALib (presumably).

So maybe it does not make much sense to create one... yet another function for the user to learn!

Is square(x) that much easier to read/comprehend than power(x,2)?
#3 - 13 Feb 2017 09:44 - Anna Maria Bigatti

If we had a square we should document how it differs from power(x,2).  So I think we'd better not.

If we have mySquare, that should be called by power(x,2).

In short: mySquare make sense, square does not (IMHO)

#4 - 13 Feb 2017 14:44 - John Abbott

- Subject changed from square fuction to square function

- Status changed from In Progress to Resolved

- Assignee set to John Abbott

- % Done changed from 10 to 80

OK, then we agree to eliminate the function square.  It will disappear the next time I do a check in (later today?)

#5 - 15 Feb 2017 18:20 - John Abbott

- Status changed from Resolved to Feedback

- % Done changed from 80 to 90

All tests pass.  I have now checked in the change.  ==> feedback

#6 - 29 Mar 2017 18:12 - John Abbott

- Target version changed from CoCoALib-0.99560 to CoCoALib-0.99550 spring 2017

#7 - 22 Apr 2017 22:46 - John Abbott

- Status changed from Feedback to Closed

- % Done changed from 90 to 100

The solution is: we do not define a square function.  Use power(...,2) instead!

#8 - 28 Apr 2017 09:31 - Anna Maria Bigatti

- Estimated time set to 1.01 h

#9 - 17 Jan 2018 12:13 - John Abbott

- Related to Design #1147: mySquare and myPowerSmallExp added
